GraphMap< GR, K, V > Class Template Reference

- Main Page
- Modules
- Classes
- Namespaces
- Files
- Related Pages

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
List of all members | Public Types | Public Member Functions | Private Member Functions
GraphMap< GR, K, V > Class Template Reference

## Detailed Description

### template<typename GR, typename K, typename V>
class lemon::concepts::GraphMap< GR, K, V >

This class describes the concept of standard graph maps, i.e. the `NodeMap`, `ArcMap` and `EdgeMap` subtypes of digraph and graph types, which can be used for associating data to graph items. The standard graph maps must conform to the ReferenceMap concept.

`#include <lemon/concepts/graph_components.h>`

Inheritance diagram for GraphMap< GR, K, V >:
[legend]

## Public Types
typedef K | Key
| The key type of the map.
typedef V | Value
| The value type of the map.
typedef Value & | Reference
| The reference type of the map.
typedef const Value & | ConstReference
| The const reference type of the map.
Public Types inherited from ReferenceMap< K, V, V &, const V & >
typedef True | ReferenceMapTag
| Tag for reference maps.
typedef K | Key
| The key type of the map.
typedef V | Value
| The value type of the map. (The type of objects associated with the keys).
typedef V & | Reference
| The reference type of the map.
typedef const V & | ConstReference
| The const reference type of the map.
Public Types inherited from ReadWriteMap< K, V >
typedef K | Key
| The key type of the map.
typedef V | Value
| The value type of the map. (The type of objects associated with the keys).
Public Types inherited from ReadMap< K, V >
typedef K | Key
| The key type of the map.
typedef V | Value
| The value type of the map. (The type of objects associated with the keys).
Public Types inherited from WriteMap< K, V >
typedef K | Key
| The key type of the map.
typedef V | Value
| The value type of the map. (The type of objects associated with the keys).

## Public Member Functions
| GraphMap (const GR &)
| Construct a new map. More...
| GraphMap (const GR &, const Value &)
| Construct a new map with default value. More...
Public Member Functions inherited from ReferenceMap< K, V, V &, const V & >
Reference | operator[] (const Key &)
| Returns a reference to the value associated with the given key.
ConstReference | operator[] (const Key &) const
| Returns a const reference to the value associated with the given key.
void | set (const Key &k, const Value &t)
| Sets the value associated with the given key.
Public Member Functions inherited from ReadWriteMap< K, V >
Value | operator[] (const Key &) const
| Returns the value associated with the given key.
void | set (const Key &, const Value &)
| Sets the value associated with the given key.
Public Member Functions inherited from ReadMap< K, V >
Value | operator[] (const Key &) const
| Returns the value associated with the given key.
Public Member Functions inherited from WriteMap< K, V >
void | set (const Key &, const Value &)
| Sets the value associated with the given key.
| WriteMap ()
| Default constructor.

## Private Member Functions
| GraphMap (const GraphMap &)
| Copy constructor. More...
template<typename CMap >
GraphMap & | operator= (const CMap &)
| Assignment operator. More...

## Constructor & Destructor Documentation

GraphMap | ( | const GR & |  | ) |
| inlineexplicit

Construct a new map for the graph.

GraphMap | ( | const GR & | ,
|  | const Value & |
| ) |  |
| inline

Construct a new map for the graph and initalize the values.

GraphMap | ( | const GraphMap< GR, K, V > & |  | ) |
| inlineprivate

Copy Constructor.

## Member Function Documentation

GraphMap& operator= | ( | const CMap & |  | ) |
| inlineprivate

Assignment operator. It does not mofify the underlying graph, it just iterates on the current item set and set the map with the value returned by the assigned map.